'*********************************************************
' Apprendre la programmation des PIC II                  *
' 2eme Exemple d'utilisation d'une entre analogique     *
' Pic utilis : 18 F 4520                                *
' Quartz : 4 Mhz                                         *
' Version 1.0 du 20 Mars 2011                            *
' Auteur PM                                              *
'*********************************************************
 
 ' directives
         Device 18F4520                 ' Pic utilis  
         XTAL = 4                       ' Frquence du quartz utilis 
                 
 ' dclaration du port B en sortie         
        TRISB=0
        Dim donnee_ana As Word
                
' Paramtrage des entres analogiques 
    ADIN_RES = 10                       'ADC sur 10 bits
    ADIN_TAD = 2_fosc                   'Source de l'horloge du convertisseur
    ADIN_STIME = 50                     'Dlai avant chantillonnage en S
    ADCON2=%10111010                  

 debut:
        PORTB = donnee_ana              'La valeur de ADIN 0 est envoye sur le port B
        Call conversion                 'appel de al fonction de conversion
        DelayMS 100                     'Dlai de 100 mS
        GoTo debut                      'Retour au dbut 
End                                     'Fin du programme


'*************** Voie AN0-AN4 - Mesure rglage courant par potentiomtre *****************

conversion:    

 
       ADCON0=%00000001                'config registre ADCON0 (Alim + slection voie)        
       ADCON0.1 = 1                    'lancement de la conversion (bit 1 de ADCON0)
   
Loop1:
       If ADCON0.1=1 Then GoTo Loop1     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       Return     
