'*********************************************************
' Apprendre la programmation des PIC high performance    *
' Acquisition de donnes avec carte SD                   *
' Pic utilis : 18 F 4520                                *
' Quartz : 20 Mhz                                        *
' Version 1.0 03/2011                                    *
' Auteur Pascal Mayeux                                   *
'********************************************************        
 
  
' directives
       
         Device 18F4520
         Declare serial_data 8  
         Symbol T9600 = 84	NO_LIST
         XTAL=20

'dclaration pour le port B
         TRISB = %01111111   
         
' Dclaration entre analogique AN4

    TRISA = %11111111         
    ADIN_RES = 10
    ADIN_TAD = FRC
    ADIN_STIME = 100
    ADCON1=%10000000
    PORTB_PULLUPS=On  



 ' dclaration des variables utilises 
 
        Dim f As Word
        Dim g As Byte
        Dim d5 As Bit
        Dim d6 As Bit
        Dim d7 As Bit
        Dim d8 As Bit
        Dim enregistre As Bit
        Dim periode As Byte
       
         
 

 ' dclaration des symbols utiliss 

               
        'led
        Symbol led1=PORTC.5
       
        'sonde de temprature
        Symbol dq=PORTD.2
        Dim temp As Word
        Dim degres As Byte
        Dim hold As Byte
        
         
        'entrees logiques
        Symbol entree1 = PORTB.1
        Symbol entree2 = PORTB.2
        Symbol entree3 = PORTB.3        
        Symbol entree4 = PORTB.4
        
        'entrees analogiques
        Dim d1 As Word
        Dim d2 As Word
        Dim d3 As Word
        Dim d4 As Word
          
        'tempo
        Symbol tempo = 1000
               
        'init
        High led1
        DelayMS 1000
        Low led1
        DelayMS 1000
        enregistre=0
        
  
            
' Version du logiciel

    EWrite 100, ["Acquisition avec carte SD version 1.0 - (c) P.Mayeux - 11/2007"]
    f=0
 
    
debut:

 
'************* Boucle principale ****************
               
               
              Toggle led1
          
  
      ' ************************ mesure entres ana *************************
                d1=  ADIn 0 
                DelayMS 5
                d2=  ADIn 1 
                DelayMS 5
                d3=  ADIn 2 
                DelayMS 5
                d4=  ADIn 3 
                DelayMS 5
                
                ' ********************** mesure entres logiques **********************
                d5=PORTB.1
                d6=PORTB.2
                d7=PORTB.3
                d8=PORTB.4                
                
                ' ************* mesure de la temprature avec ds 1820 *****************
                OWrite dq,1,[$CC,$44]   'envoi calcul temprature vers ds1820
                Repeat
                    DelayMS 25
                    ORead dq,4,[hold]   'mise de la valeur reue dans la variable hold
                    Toggle led1
                Until hold <> 0
                OWrite dq,1,[$CC,$BE]
                ORead dq,2,[temp.LowByte,temp.HighByte,hold,hold,hold,hold,hold,degres]
                temp=(((temp>>1)*100)-25) + (((degres-hold)*100)/degres)
                '***********************************************************************

                ' ************* mesure de la temprature avec ds 18B20 *****************                 
                'OWrite dq, 1, [$CC, $4E, DumTh, DumTl, $5F] 'AD en 11 bits                 
                'OWrite dq,1,[$CC,$44]   'envoi calcul temprature vers dsb1820
                'Repeat
                    'DelayMS 30
                    'ORead dq,4,[hold]   'mise de la valeur reue dans la variable hold
                    'Toggle led1
                'Until hold <> 0
                'OWrite dq,1,[$CC,$BE]
                'ORead dq,2,[temp.LowByte,temp.HighByte,hold,hold,hold,hold,hold,degres]
                'temp=(((temp>>1)*100)-25) + (((degres-hold)*100)/degres)
                '***********************************************************************

             
                   
             DelayMS 100             
             SerOut PORTC.6 , T9600 , [Dec temp/100," ; ", Dec d1," ; ",Dec d2," ; ",Dec d3," ; ",Dec d4," ;Logiques; ", Dec d5," ; ", Dec d6," ; ", Dec d7," ; ", Dec d8," ; " ,13,10] 
                            
            Low led1
            DelayMS 500  
                      
    GoTo debut



End
             
             

