'*********************************************************
' Apprendre la programmation des PIC high Performance    *
' Traceur  GPS                                          *
' Pic utilis : 18 F 4520                                *
' Quartz : 20 Mhz                                        *
' Version 1.0 03/2011                                    *
' Auteur Pascal Mayeux                                   *
'*********************************************************
 
' directives

          Declare serial_data 8  
          Symbol T4800 = 188	NO_LIST
          Symbol T9600 = 84	NO_LIST
          Device = 18F4520
          XTAL = 20
          TRISA=0
         
 ' dclaration des variables utilises 
 
        Dim Info_GPS As String * 80  ' tableau o seront stocks les infos du GPS
        Dim t_valid As string*1
        Dim heure As string*6
        Dim valid As Bit
     
        Symbol led = PORTA.2
        'Symbol led = PORTC.4
        Symbol switch1=PORTB.4
        Symbol switch2=PORTB.5
        Symbol switch3=PORTB.6
        Symbol switch4=PORTB.7
 
        'carte SD
        Symbol tx_sd = PORTB.2
        Symbol rx_sd = PORTB.3
        Symbol raz = PORTD.7  
        Symbol sd_in = PORTB.1   
        Dim serdata As Byte  
        
        'calcul du temps d'acquisition
        Dim temps As Word  
       
       
' Version du logiciel

    EWrite 150, ["Traceur GPS version 1.0 - (c) P.Mayeux - 03/2011"]

'init
     temps=0
                       High led                 
                       DelayMS 1000
                       Low led                       
debut:
   
   valid = 0
   If switch1=1 And switch2=1 And switch3=1 And switch4=1 Then valid = 1                    '1s
   If switch1=0 And switch2=1 And switch3=1 And switch4=1 And temps = 30 Then valid = 1     '30s
   If switch1=1 And switch2=0 And switch3=1 And switch4=1 And temps = 60 Then valid = 1     '1mn
   If switch1=1 And switch2=1 And switch3=0 And switch4=1 And temps = 600 Then valid = 1    '10mn
   If switch1=1 And switch2=1 And switch3=1 And switch4=0 And temps = 900 Then valid = 1    '15mn
   If switch1=0 And switch2=1 And switch3=1 And switch4=0 And temps = 1800 Then valid = 1   '30mn
   If switch1=1 And switch2=0 And switch3=1 And switch4=0 And temps = 3600 Then valid = 1   '1h 
   If switch1=1 And switch2=1 And switch3=0 And switch4=0 And temps = 4500 Then valid = 1   '1h 15mn
   If switch1=0 And switch2=0 And switch3=0 And switch4=0 And temps = 7200 Then valid = 1   '2h
  
   
    
   SerIn PORTC.4,T4800,[Wait("$GPRMC"),Info_GPS]
   
        
        t_valid     = Mid$(Info_GPS,13 ,1)
        heure       = Mid$(Info_GPS,2 ,6)

            If t_valid="A" And valid = 1 And sd_in=0 Then
                High raz  
                High led
                DelayMS 200          
                SerOut tx_sd , T9600 , ["fputs mesure.txt /a ", "$GPRMC",Info_GPS ,13,10]
                temps= 0 
                Low led
                DelayMS 200
            End If

      If t_valid="A" Then temps = temps + 1 
      If sd_in=1 Then temps = 0
         
  fin2:
 
   GoTo debut

End
                
